//-------------------------------------------------------------------------//
//  Steve Berardi - period 1                                               //
//-------------------------------------------------------------------------//
//  TIC TAC TOE - february 2001                                            //
//-------------------------------------------------------------------------//

  #include <iostream.h>
  #include "d:\apclass\apmatrix.h"
  #include "d:\apclass\randgen.cpp"

  //#pragma hdrstop

  #include "CMUgraphicsLib\cmugraphics.h"

//-------------------------------------------------------------------------//
void DrawBoard(window &game_window, int x, int y)  //---> DRAW BOARD ()
{
//draws the tic tac toe board (3 by 3)

   game_window.SetPen(WHITE, 5);  //set pen to white
   
   game_window.DrawLine(x*.2 , y*.3, x*.2 , y*.75);  //draw vertical lines
   game_window.DrawLine(x*.35, y*.3, x*.35, y*.75);
   game_window.DrawLine(x*.5 , y*.3, x*.5 , y*.75);
   game_window.DrawLine(x*.65, y*.3, x*.65, y*.75);

   game_window.DrawLine(x*.2, y*.3 , x*.65, y*.3);  //draw horizontal lines
   game_window.DrawLine(x*.2, y*.45, x*.65, y*.45);
   game_window.DrawLine(x*.2, y*.6 , x*.65, y*.60);
   game_window.DrawLine(x*.2, y*.75, x*.65, y*.75);

   return;
}
//-------------------------------------------------------------------------//
void DrawScoreboard(window &game_window, int win, int lose, int tie)
{
//draws the scoreboard, base on win, lose, and tie values
//displays scoreboard in lower right corner of window

   int x, y;         //stores size of window

   game_window.GetWindowSize(x,y);   //get window size

	game_window.SetPen(WHITE);                   //white fore color
	game_window.SetFont(20, PLAIN, ROMAN);       //roman, 20 size
	game_window.DrawString(x*.6, y*.8, "[WIN]");  //win label
	game_window.DrawString(x*.7, y*.8, "[LOSE]"); //lose label
	game_window.DrawString(x*.82, y*.8, "[TIE]");  //tie label
    
	game_window.DrawInteger(x*.61, y*.86, win);    //display total wins
	game_window.DrawInteger(x*.71, y*.86, lose);   //display total losses
	game_window.DrawInteger(x*.83, y*.86, tie);    //display total ties

  return;
}
//-------------------------------------------------------------------------//
void DrawMark(window &game_window, image mark_image, int row, int col)
{
//draws a (mark_image) in corresponding (row, col) of the game board

   int x,y;  //stores size of window

   game_window.GetWindowSize(x,y);   //get window size
                                                                 // CELL
                                                                 //-------
	if (row == 0 && col == 0)                                    // (0,0)
	  game_window.DrawImage(mark_image, x*.24, y*.32, 45, 45);
    
	else if (row == 0 && col == 1)                               // (0,1)
	  game_window.DrawImage(mark_image, x*.39, y*.32, 45, 45);
	
	else if (row == 0 && col == 2)                               // (0,2)
	  game_window.DrawImage(mark_image, x*.54, y*.32, 45, 45);

	else if (row == 1 && col == 0)                               // (1,0)
	  game_window.DrawImage(mark_image, x*.24, y*.47, 45, 45);

	else if (row == 1 && col == 1)                               // (1,1)
	  game_window.DrawImage(mark_image, x*.39, y*.47, 45, 45);
	
	else if (row == 1 && col == 2)                               // (1,2)
	  game_window.DrawImage(mark_image, x*.54, y*.47, 45, 45);

	else if (row == 2 && col == 0)                               // (2,0)
	  game_window.DrawImage(mark_image, x*.24, y*.62, 45, 45);
	
	else if (row == 2 && col == 1)                               // (2,1)
	  game_window.DrawImage(mark_image, x*.39, y*.62, 45, 45);

	else if (row == 2 && col == 2)                               // (2,2)
	  game_window.DrawImage(mark_image, x*.54, y*.62, 45, 45);

}
//-------------------------------------------------------------------------//
bool BoxAvailable(apmatrix<char> grid, int row, int col)  //--> BOX AVAILABLE()
{
//checks if (row,col) cell is available, meaning that the user or computer
//has not placed a mark there (tests to see if 'a' is in cell)

  bool available;    //is box available?

  if ( grid[row][col] == 'a' )  //check to see if the cell contains an 'a'
    available = true;
  else
	available = false;    //box is not available

  return available;
}
//-------------------------------------------------------------------------//
int AvailableSpots(apmatrix<char> &game_board)   //----> AVAILABLE SPOTS()
{
//returns the number of available spots in the game_board
//an available spot is identified by an 'a'

  int a_spots=0;    //stores number of available spots left..

  for (int rows=0; rows < 3; rows++)   //loop through entire matrix
  {
	for (int cols=0; cols < 3; cols++)
	{
      if (game_board[rows][cols] == 'a') //if box is available ('a')
		a_spots++;    //increment available spots.
	}
  }

  return a_spots;
}
//-------------------------------------------------------------------------//
char IsWinner(apmatrix<char> &board)                  //----> IS WINNER()
{
//determines if there is a winner.. (returns 'a', if no winner)

  char winner='a';  //character to determine who winner is

 ///----Rows:
 if ( board[0][0] == board[0][1] && board[0][0] == board[0][2] )
  winner = board[0][0];          //ROW ONE

 else if ( board[1][0] == board[1][1] && board[1][0] == board[1][2] )
  winner = board[1][0];          //ROW TWO

 else if ( board[2][0] == board[2][1] && board[2][0] == board[2][2] )
  winner = board[2][0];          //ROW THREE
 ///----Columns:
 else if ( board[0][0] == board[1][0] && board[0][0] == board[2][0] )
  winner = board[0][0];          //COLUMN ONE

 else if ( board[0][1] == board[1][1] && board[0][1] == board[2][1] )
  winner = board[0][1];          //COLUMN TWO

 else if ( board[0][2] == board[1][2] && board[0][2] == board[2][2] )
  winner = board[0][2];          //COLUMN THREE
 ///----Diagonals:
 else if ( board[0][0] == board[1][1] && board[0][0] == board[2][2] )
  winner = board[0][0];          //DIAGONAL (LEFT TO RIGHT)
 
 else if ( board[0][2] == board[1][1] && board[0][2] == board[2][0] )
  winner = board[0][2];          //DIAGONAL (RIGHT TO LEFT)

 return winner;
}
//-------------------------------------------------------------------------//
bool GetSelectedBox(int screen_x, int screen_y, int mouseX, int mouseY, int &row, int &col)
{
//sets the (row) and (col) to currently selected box in the tic tac toe
//board. (row) and (col) refer to the row and column in the apmatrix.
//RETURNS: 'true'--> user clicked on box
//         'false'-> user did not click on a box (somewhere else on window)
//
   int x=screen_x, y=screen_y;   //store in shorter variable names
   bool ClickedBox=false;        //did user click a box?

	if ( (mouseX >= x*.2 && mouseX < x*.35) && (mouseY >= y*.3 && mouseY < y*.45) )
	{  //cell [0][0] -- ROW 1
       row = 0; col = 0;   //set row and column variables         (0,0)
       ClickedBox = true;  //user clicked box
	}
	else if ( (mouseX >= x*.35 && mouseX < x*.5) && (mouseY >= y*.3 && mouseY < y*.45) )
    {  //cell [0][1] -- ROW 1
       row = 0; col = 1;   //set row and column variables         (0,1)
       ClickedBox = true;  //user clicked box
	}
    else if ( (mouseX >= x*.5 && mouseX < x*.65) && (mouseY >= y*.3 && mouseY < y*.45) )
    {  //cell [0][2] -- ROW 1
       row = 0; col = 2;   //set row and column variables         (0,2)
       ClickedBox = true;  //user clicked box
	}
	else if ( (mouseX >= x*.2 && mouseX < x*.35) && (mouseY >= y*.45 && mouseY < y*.6) )
	{  //cell [1][0]  -- ROW 2
       row = 1; col = 0;   //set row and column variables         (1,0)
       ClickedBox = true;  //user clicked box
	}
    else if ( (mouseX >= x*.35 && mouseX < x*.5) && (mouseY >= y*.45 && mouseY < y*.6) )
    {  //cell [1][1]  -- ROW 2
       row = 1; col = 1;   //set row and column variables         (1,1)
       ClickedBox = true;  //user clicked box
	}
    else if ( (mouseX >= x*.5 && mouseX < x*.65) && (mouseY >= y*.45 && mouseY < y*.6) )
    {  //cell [1][2]  -- ROW 2
       row = 1; col = 2;   //set row and column variables         (1,2)
       ClickedBox = true;  //user clicked box
	}
    else if ( (mouseX >= x*.2 && mouseX < x*.35) && (mouseY >= y*.6 && mouseY < y*.75) )
    {  //cell [2][0]  -- ROW 3
       row = 2; col = 0;   //set row and column variables         (2,0)
       ClickedBox = true;  //user clicked box
	}
    else if ( (mouseX >= x*.35 && mouseX < x*.5) && (mouseY >= y*.6 && mouseY < y*.75) )
    {  //cell [2][1]  -- ROW 3
       row = 2; col = 1;   //set row and column variables         (2,1)
       ClickedBox = true;  //user clicked box
	}
    else if ( (mouseX >= x*.5 && mouseX < x*.65) && (mouseY >= y*.6 && mouseY < y*.75) )
    {  //cell [2][2]  -- ROW 3
       row = 2; col = 2;   //set row and column variables         (2,2)
       ClickedBox = true;  //user clicked box
	}

  return ClickedBox;
}
//-------------------------------------------------------------------------//
void ComputerRows(apmatrix<char> &board, char user_mark, int &r, int &c)
{
//finds out if the computer should block the user from winning in a row
  int user_marks=0;

  for (int rows=0; rows < 3; rows++)       //loop through rows of matrix
  {
	user_marks = 0; //reset user marks

	for (int cols=0; cols < 3; cols++)
	{
      if (board[rows][cols] == user_mark) //if cell has a user mark
	  {
		user_marks++;  //increment user marks for row
	  }
	  else
	  {
		r = rows;  //store last row that had no user mark
	    c = cols;  //store last col that had no user mark
	  }
	}

	if ( user_marks==2 && BoxAvailable(board, r, c) ) //more than 2 user marks
	  break;  //if more than 2 marks, and box available, break out of loop
	else
	  r = -1; //rows are OK, set r to -1
  }

  return;
}
//-------------------------------------------------------------------------//
void ComputerCols(apmatrix<char> &board, char user_mark, int &r, int &c)
{
//finds out if the computer should block the user from winning in a column
  int user_marks=0;

  for (int cols=0; cols < 3; cols++)    //loop through columns of matrix
  {
	user_marks = 0; //reset user marks

	for (int rows=0; rows < 3; rows++)
	{
      if (board[rows][cols] == user_mark) //if cell has a user mark
	  {
		user_marks++;  //increment user marks for row
	  }
	  else
	  {
		r = rows;  //store last row that had no user mark
	    c = cols;  //store last col that had no user mark
	  }
	}

	if ( user_marks==2 && BoxAvailable(board, r, c) )  //more than 2 user marks
	  break;  //if more than 2 marks, and box available, break out of loop
	else
	  r = -1;  //columns are OK, set r to -1
  }

  return;
}
//-------------------------------------------------------------------------//
void ComputerDiag(apmatrix<char> &board, char user_mark, int &r, int &c)
{
//finds out if the computer should block the user from winnning diagonally
  int user_marks=0;

  for (int left=0; left < 3; left++)
  {
	if (board[left][left] == user_mark)  //if cell has user mark, increment:
	{
	 user_marks++;  //increment user marks (another one found)
	}
	else
	{
	 r = left;   //set the row and column, where computer should mark
	 c = left;
	}
  }

	if ( user_marks==2 && BoxAvailable(board, r, c) ) //if > 2, make mark
	  return;
	else
	  r = -1; //set to -1, signifies that the user cant win this diagonal

	user_marks=0; //reset to zero, because next diagonal is being checked

   for (int rows=0; rows < 3; rows++)
   {
	 if ( board[rows][2-rows] == user_mark )
	 {
       user_marks++;  //another user_mark found, increment
	 } 
     else
	 {
	   r = rows;      //set row and column, of last cell w/o user mark
	   c = 2-rows;
	 }
   }

	if ( user_marks==2 && BoxAvailable(board, r, c) ) //if > 2, make mark
	  return;
	else
	  r = -1;  //set to -1, signifies that the user cant win this diagonal

  return;
}
//-------------------------------------------------------------------------//
bool CompCanWin(apmatrix<char> &game_board, char comp_mark, int &r, int &c)
{
//decides if computer can win with next move...
//sets value of r (row), c (col) corresponding with winning box that
//is in the game_board.

  int box_r, box_c; //box row and column of winning box
  bool CanWin=false; //can computer win with next move?

  ComputerRows(game_board, comp_mark, box_r, box_c);  // < ROWS >
   if (box_r != -1 && !CanWin)
   {
     r = box_r;                           //row of winning box
	 c = box_c;                           //column of winning box
     CanWin = true;                       //computer can win on next move
   }
  ComputerCols(game_board, comp_mark, box_r, box_c);  // < COLUMNS >
   if (box_r != -1 && !CanWin)
   {
     r = box_r;                           //row of winning box
	 c = box_c;                           //column of winning box
     CanWin = true;                       //computer can win on next move
   }
  ComputerDiag(game_board, comp_mark, box_r, box_c);  // < DIAGONALS >
   if (box_r != -1 && !CanWin)
   {
     r = box_r;                           //row of winning box
	 c = box_c;                           //column of winning box
     CanWin = true;                       //computer can win on next move
   }

  return CanWin;
}
//-------------------------------------------------------------------------//
void ComputerMove(window &game_window, apmatrix<char> &game_board, image comp_image, char comp_mark, char user_mark)
{
//the << Artificial Intelligence >>..
//first, computer makes sure the game is still going, then it checks to
// see if it can win with the next move (makes move, if it can win). if it
// cant win, then it looks to see if it needs to block the user from winning
// in their next move. if the user cannot win in their next move, then the
// computer will randomly mark an available box.

  RandGen rNumber;     //random generator object
  int row, col;        //row and column from random generator
  int block_r, block_c; //used if the computer HAS to move, to stop user from win
  bool MadeMove=false; //has computer made his move yet?

  if (!AvailableSpots(game_board) || IsWinner(game_board) != 'a') //game over?
	MadeMove = true;  //set to true, because game is over (winner or board is full)

  if ( CompCanWin(game_board, comp_mark, block_r, block_c) && !MadeMove) //CAN COMPUTER WIN?
  {
     DrawMark(game_window, comp_image, block_r, block_c); //draw mark on screen
     game_board[block_r][block_c] = comp_mark;      //mark virtual game_board
     MadeMove = true;                       //computer makes move
  }

  ComputerRows(game_board, user_mark, block_r, block_c);  // < ROWS >
   if (block_r != -1 && !MadeMove)
   {
     DrawMark(game_window, comp_image, block_r, block_c); //draw mark on screen
     game_board[block_r][block_c] = comp_mark;      //mark virtual game_board
     MadeMove = true;                       //computer makes move
   }
  ComputerCols(game_board, user_mark, block_r, block_c);  // < COLUMNS >
   if (block_r != -1 && !MadeMove)
   {
     DrawMark(game_window, comp_image, block_r, block_c); //draw mark on screen
     game_board[block_r][block_c] = comp_mark;      //mark virtual game_board
     MadeMove = true;                       //computer makes move
   }
  ComputerDiag(game_board, user_mark, block_r, block_c);  // < DIAGONALS >
   if (block_r != -1 && !MadeMove)
   {
     DrawMark(game_window, comp_image, block_r, block_c); //draw mark on screen
     game_board[block_r][block_c] = comp_mark;      //mark virtual game_board
     MadeMove = true;                       //computer makes move
   }

 while(!MadeMove) //continue getting a random cell, until available one is found
 {
  row = rNumber.RandInt(0,2);    //random integer, 0 to 2 (rows)
  col = rNumber.RandInt(0,2);    //random integer, 0 to 2 (columns)

  if ( BoxAvailable(game_board, row, col) ) //if box is available, make move
  {
   DrawMark(game_window, comp_image, row, col); //draw mark on screen
   game_board[row][col] = comp_mark;      //mark virtual game_board
   MadeMove = true;                       //computer makes move
  }
 }

  return;
}
//-------------------------------------------------------------------------//
void SplashScreen()                               //---> SPLASH SCREEN ()
{
//displays a splash screen, until the user hits the enter key

  window splash(640, 480, 0, 0);      //define window object
  image intro_pic("intro.jpg");       //define picture object

  bool HitEnter=false;                //did user hit enter?
  char key_press;                     //key user pressed (the char)
  int x, y;                           //dimensions of window

  splash.SetWaitClose(false);          //dont wait for mouse click to close
  splash.ChangeTitle("Tic Tac Toe - Introduction");   //set caption of window
  splash.GetWindowSize(x, y);          //store window size

  splash.SetBrush(BLACK);                   //set brush to BLACK
  splash.DrawRectangle(0, 0, x, y, FILLED);  //fill background black
  splash.SetFont(26, ITALICIZED, ROMAN);   //set the font to courier
  splash.SetPen(WHITE);                   //set font color to white
  splash.DrawString(x*.35, y*.9, "Hit enter to play...");  //draw string
  splash.DrawImage(intro_pic, (x-360)/2, y*.1, 360, 180);   //display intro pic

  do
  {
   splash.WaitKeyPress(key_press);   //loop until user hits 'enter' key
   if (int(key_press) == 13)         //13 is code for enter
     HitEnter = true;                //user hit enter
  }while(!HitEnter);

  return;
}
//-------------------------------------------------------------------------//
char GetUserMark()                                //---> GET USER MARK ()
{
//get the user's desired mark (X or O)
  int x, y;                               //size of window
  int mouseX, mouseY;                     //coordinates, when user clicks
  int xBoxX1, xBoxX2, xBoxY1, xBoxY2;     //binding box of X image
  int oBoxX1, oBoxX2, oBoxY1, oBoxY2;     //binding box of O image
  char user_selection;                    //stores final user selection
  bool ValidChoice=false;                 //did user select valid area on window?
  window get_mark(460,220, 0, 0);         //get mark window
  image x_img("x.jpg"), o_img("o.jpg");   //x and o images

  get_mark.SetWaitClose(false);          //dont wait for mouse click to close
  get_mark.GetWindowSize(x,y);               //get size of window
  get_mark.ChangeTitle("Select X's or O's");   //change caption of window
  get_mark.SetBrush(BLACK);                   //set brush to BLACK
  get_mark.DrawRectangle(0, 0, x, y, FILLED);  //fill background black
  get_mark.SetFont(26, ITALICIZED, ROMAN);   //set the font to courier
  get_mark.SetPen(WHITE);                   //set font color to white
  get_mark.DrawString(x*.2, y*.1, "Select your mark (X's or O's):");  //draw string

  get_mark.DrawImage(x_img, x*.3, y*.45, 45, 45);  //draw X image
  get_mark.DrawImage(o_img, x*.6, y*.45, 45, 45);  //draw O image

 //set binding box of X image:
  xBoxX1 = x*.3;          //x1 of X image
  xBoxX2 = xBoxX1 + 45;   //image is 45 pixels wide..
  xBoxY1 = y*.45;         //y1 of X image
  xBoxY2 = xBoxY1 + 45;   //image is 45 pixels long..


 //set binding box of O image:
  oBoxX1 = x*.6;          //x1 of O image
  oBoxX2 = oBoxX1 + 45;   //image is 45 pixels wide..
  oBoxY1 = y*.45;         //y1 of O image
  oBoxY2 = oBoxY1 + 45;   //image is 45 pixels long..


  do     //loop until user clicks in a valid area (X or O binding boxes)
  {
   get_mark.WaitMouseClick(mouseX, mouseY);  //get mouse coordinates
    if ((mouseX >= xBoxX1 && mouseX <= xBoxX2) && (mouseY >= xBoxY1 && mouseY <= xBoxY2))
	{
      user_selection = 'x';  //set user selection to X
	  ValidChoice = true;    //user selected valid choice: [X]
    }
	else if ((mouseX >= oBoxX1 && mouseX <= oBoxX2) && (mouseY >= oBoxY1 && mouseY <= oBoxY2))
    {
      user_selection = 'o';  //set user selection to O
      ValidChoice = true;    //user selected valid choice: [O]
	}
  }while(!ValidChoice); //if not a valid choice, continue looping

  return user_selection; //return the mark user selected
}
//-------------------------------------------------------------------------//
bool PlayAgain()                                 //---> PLAY AGAIN ()
{
//ask user if they want to play again.
  int x, y;                               //size of window
  int mouseX, mouseY;                     //coordinates, when user clicks
  int yBoxX1, yBoxX2, yBoxY1, yBoxY2;     //binding box of 'yes' image
  int nBoxX1, nBoxX2, nBoxY1, nBoxY2;     //binding box of 'no' image
  char user_selection;                    //stores final user selection (y or n)
  bool plyAgain=false;                    //play again?
  bool ValidChoice=false;                 //did user select valid area on window?
  window play_again(460,220, 0, 0);         //play again window
  image yes_img("yes.jpg"), no_img("no.jpg");   //'yes' and 'no' images

  play_again.SetWaitClose(false);          //dont wait for mouse click to close
  play_again.GetWindowSize(x,y);               //get size of window
  play_again.ChangeTitle("Play Again?");   //change caption of window
  play_again.SetBrush(BLACK);                   //set brush to BLACK
  play_again.DrawRectangle(0, 0, x, y, FILLED);  //fill background black
  play_again.SetFont(26, ITALICIZED, ROMAN);   //set the font to courier
  play_again.SetPen(WHITE);                   //set font color to white
  play_again.DrawString(x*.2, y*.1, "Would you like to play again?");  //draw string

  play_again.DrawImage(yes_img, x*.3, y*.45, 60, 40);  //draw 'yes' image
  play_again.DrawImage(no_img, x*.6, y*.45, 60, 40);  //draw 'no' image

 //set binding box of 'yes' image:
  yBoxX1 = x*.3;          //x1 of 'yes' image
  yBoxX2 = yBoxX1 + 60;   //image is 60 pixels wide..
  yBoxY1 = y*.45;         //y1 of X image
  yBoxY2 = yBoxY1 + 40;   //image is 40 pixels long..


 //set binding box of 'no' image:
  nBoxX1 = x*.6;          //x1 of 'no' image
  nBoxX2 = nBoxX1 + 60;   //image is 60 pixels wide..
  nBoxY1 = y*.45;         //y1 of 'no' image
  nBoxY2 = nBoxY1 + 40;   //image is 40 pixels long..


  do     //loop until user clicks in a valid area ('yes' or 'no' binding boxes)
  {
   play_again.WaitMouseClick(mouseX, mouseY);  //get mouse coordinates
    if ((mouseX >= yBoxX1 && mouseX <= yBoxX2) && (mouseY >= yBoxY1 && mouseY <= yBoxY2))
	{
      user_selection = 'y';  //set user selection to 'y'
	  ValidChoice = true;    //user selected valid choice: 'yes'
    }
	else if ((mouseX >= nBoxX1 && mouseX <= nBoxX2) && (mouseY >= nBoxY1 && mouseY <= nBoxY2))
    {
      user_selection = 'n';  //set user selection to 'n'
      ValidChoice = true;    //user selected valid choice: 'no'
	}
  }while(!ValidChoice); //if not a valid choice, continue looping

  if (user_selection == 'y')   //if user selected 'yes'
   plyAgain = true;
  else                       //else, user selected 'no'
   plyAgain = false;

  return plyAgain; //return boolean, true (if play again), false (dont play)
}
//-------------------------------------------------------------------------//
char PlayGame(char user_mark, int win, int lose, int tie) //---> PLAY GAME ()
{
//function for playing one game
  int x, y;                           //size of window
  int mouseX, mouseY;                 //coordinates of mouse, when user clicks
  int sel_row=-1, sel_col=-1;         //user selection: row and column of MATRIX
  char outcome;                       //game outcome: w (win), l (lose), t (tie)
  bool GameOver=false;                //is game over?
  window game(640, 480, 0, 0);        //define the game window object
  image x_img("x.jpg"), o_img("o.jpg");   //x and o images
  apmatrix<char>  game_board(3,3);    //virtual game board stored in memory

  for (int rows=0; rows < 3; rows++)   //loop throught matrix, fill w/ 'a'
	for (int cols=0; cols < 3; cols++)
	  game_board[rows][cols] = 'a';    //set next cell to 'a' (available)

  game.ChangeTitle("Tic Tac Toe - Game Window");  //set title
  game.GetWindowSize(x,y);                        //store window size
  game.SetBrush(BLACK);                   //set brush to BLACK
  game.DrawRectangle(0, 0, x, y, FILLED);  //fill background black
  game.SetPen(FORESTGREEN);                       //forest green pen
  game.SetFont(40, BOLD, ROMAN);                   //font = 40, bold
  game.DrawString(x*.2, y*.1, "Tic Tac Toe Game"); //draw title

  game.SetFont(20, ITALICIZED, ROMAN);             //font = 20, italic
  game.SetPen(WHITE);                              //black pen
  game.DrawString(x*.05, y*.2, "Click a box with no mark to make your move:");
  
  DrawScoreboard(game, win, lose, tie);  //draw scoreboard

  if (user_mark == 'x')
    game.DrawString(x*.08, y*.85, "Your mark is: [ X ]");  //user mark is X
  else
	game.DrawString(x*.08, y*.85, "Your mark is: [ O ]");  //user mark is O

  DrawBoard(game,x,y);   //draw the tic tac toe board

  do           //loop until game is over..
  {
   game.WaitMouseClick(mouseX, mouseY);    //wait until mouse is click
   if(GetSelectedBox(x,y,mouseX,mouseY, sel_row, sel_col)) //user selected box
   {
	  
     if (BoxAvailable(game_board, sel_row, sel_col))  //if box is available, mark:
	 {
      if (user_mark == 'x')  //user mark is X
	  {
		DrawMark(game, x_img, sel_row, sel_col);    //draw X mark in (r,c)
		game_board[sel_row][sel_col] = 'x';         //set box to users spot
		Sleep(500);                                 //pause for 500 ms, 'thinking'
	    ComputerMove(game, game_board, o_img, 'o', 'x'); // COMPUTER MOVE
	  }
      else                   //user mark is O
	  {
		DrawMark(game, o_img, sel_row, sel_col);    //draw O mark in (r,c)
		game_board[sel_row][sel_col] = 'o';         //set box to users spot
		Sleep(500);                                 //pause for 500 ms, 'thinking'
	    ComputerMove(game, game_board, x_img, 'x', 'o'); // COMPUTER MOVE
	  }
	 }
   }
	
   if (IsWinner(game_board) != 'a')  //is there a winner yet?
   {
	game.SetPen(YELLOW);  //set pen to yellow
	game.SetFont(19, ITALICIZED, ROMAN); //set font: size 19, italic
    GameOver = true;  //game is now over, since winner determined
    if (IsWinner(game_board) == user_mark)  //if winner is user mark
	{
      game.DrawString(x*.3,y*.92,"YOU WIN!! (click mouse to continue...)");
	  outcome = 'w';                        //outcome is w, (win)
	}
	else
	{
	  game.DrawString(x*.3,y*.92,"YOU LOSE. (click mouse to continue...)");
	  outcome = 'l';                        //else, outcome is l, (lose)
	}
   }
   else if (!AvailableSpots(game_board))  //check if board is full:
   {
	game.SetPen(YELLOW);                 //set fore color: yellow
	game.SetFont(19, ITALICIZED, ROMAN);  //font: 19, italic
    GameOver = true;  //GAME OVER, its a tie (no more available boxes)
	game.DrawString(x*.3,y*.92,"ITS A TIE. (click mouse to continue...)");
    outcome = 't';  //no more available spots, outcome is t, (tie)
   }

  }while(!GameOver);   //if game is over, then end loop

  return outcome;
}
//-------------------------------------------------------------------------//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//-------------------------------------------------------------------------//
int main()                                          //--->  MAIN ()
{ 
//++++++----> START OF PROGRAM <----++++++//

  char user_mark;   //character of user's desired mark (X or O)
  char last_game;   //outcome of last game, w (win), l (lose), t (tie)
  int win=0, lose=0, tie=0;  //tally of total win, lose, tie

  SplashScreen();                    //display splash screen
  user_mark = GetUserMark();         //get user's desired mark

  do   //play until user decides not to play again
  {
   last_game = PlayGame(user_mark, win, lose, tie);   // << PLAY GAME >> //

   if (last_game == 'w')         //last game was win    [WIN]
	 win++;                      //increment wins
   else if (last_game == 'l')    //last game was loss   [LOSE]
	 lose++;                     //increment losses
   else if (last_game == 't')    //last game was tie    [TIE]
	 tie++;                      //increment ties

  }while(PlayAgain());   //loop until user selects 'no' to: play again?

  return 0;
}
//-------------------------------------------------------------------------//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//-------------------------------------------------------------------------//
